/* +-------------------------------------------------------------------+ */
/* |  MCyA.csi.ull.es Curso 2002-2003                                  | */
/* |  pat2dat.c                                                        | */
/* |                                                                   | */
/* |    Transforma un fichero SNNS .pat a un fichero .dat raw ascii    | */
/* |       utilizable por sangers                                      | */
/* |                                                                   | */
/* |    Autor: Patricio Garca Bez                                    | */
/* |    Fecha: 3/1/2003                                                | */
/* |                                                                   | */
/* +-------------------------------------------------------------------+ */


#include <stdio.h>
#include "pat_scan.h"
#include "pat_parse.h"
#include "hermat.h"

char *program;

void error(char *msg)
{
    fprintf(stderr,"%s: %s\n", program, msg);
}

int write_dat_des(FILE *fdat, FILE *fdes)
{
    escribe_matriz(fdat, no_of_pattern, no_of_input, (matriz) patin);

    if (fdes != NULL) {
	escribe_matriz(fdes, no_of_pattern, no_of_output, (matriz) patout);
    }

    return (0);
}

void help()
{

  fprintf(stderr, "Uso: %s [-d filedes] < filepat > filedat\n", program);
  fprintf(stderr, "Transforma un fichero de patrones tipo SNNS (.pat) en uma matriz de datos raw ascii.\n");
  fprintf(stderr, "Opciones:\n");
  fprintf(stderr, "\tfiledes: Nombre del fichero para guardar las salidas deseadas\n");
  exit(-1);
}

void info()
{
  fprintf(stderr, "No. of patterns     : %d\n", no_of_pattern);
  fprintf(stderr, "No. of input units  : %d\n", no_of_input);
  fprintf(stderr, "No. of output units : %d\n", no_of_output);
}

int main(int argc, char **argv)
{
  extern char *optarg;
  extern int optind;
  char c;

  FILE *in_file = stdin;
  FILE *out_file = stdout;
  FILE *outdes_file = NULL;

  program = argv[0];

  while ((c = getopt(argc, argv, "d:h")) != -1)
    switch (c) {
    case 'd':
	if ((outdes_file = fopen(optarg, "w")) == NULL) {
	    error(optarg);
	    perror(program);
	    return(1);
	}
	break;
    case 'h':
      help();
      return(0);
      break;
    default:
      error("parametros inadecuados");
      return(1);
  }
  if (optind != argc) {
      error("parametros inadecuados");
      return(1);
  }

  scanner_init_scanner(in_file);

  if (parse_pattern_file() != 0) { 
      error("Fichero de patrones incorrecto");
      return(1);
  }

  if (write_dat_des(out_file, outdes_file) != 0) {
      error("Ha habido problemas en la escritura de datos");
       return(1);
  }

  info();

  return(0);
}
